/*
 * @Author: kael 
 * @Date: 2020-11-05 18:25:42 
 * @Last Modified by: kael
 * @Last Modified time: 2021-06-01 14:27:41
 */

const axios = require('axios');
const conf = global.config.futu;
const logger = require('../logger')();

function apply(name) {
  let headers = { Authorization: conf.auth };
  let url = `${conf.base}${conf[name]}`;
  logger.info(`Query ${name}: ${url}`);
  return axios
    .get(url, { headers })
    .then(resp => {
      if (!resp || !resp.data || resp.data.code !== 0) {
        logger.error(name, 'fetch futu error.');
        throw new Error('fetch futu error.');
      }
      return resp.data.data;
    });
}

exports.position = () => apply('position');
exports.following = () => apply('following');