/*
 * @Author: kael 
 * @Date: 2021-06-01 13:46:32 
 * @Last Modified by: kael
 * @Last Modified time: 2021-06-01 14:19:44
 */

const fs = require('fs');
const { Console } = console;
const logfile = '/tmp/quote-observer.log';

const Logger = new Console(
  fs.createWriteStream(logfile, {
    flags: 'w',
    encoding: 'utf8',
  })
);

fs.writeFileSync(logfile, '');

module.exports = () => {
  let error = (new Error()).stack.toString().split('\n')[2] || '';
  let filename = (error.match(/[\\\/\(]([-\w\.]+.\w+):\d+:\d+\)$/) || [])[1] || 'unknown';
  let logger = {};
  'trace,debug,info,warn,error,fatal,mark'.split(',').forEach(name => {
    logger[name] = (...args) => {
      Logger.info(`[${(new Date()).toISOString()}] [${filename}] [${name.toUpperCase()}]`, ...args);
    };
  });
  return logger;
};
